'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;desc = parent = getter = undefined;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _SegmentJs = require('../../Segment.js');var _SegmentJs2 = _interopRequireDefault(_SegmentJs);var _QueryOptionUtilJs = require(
'../QueryOptionUtil.js');var _QueryOptionUtilJs2 = _interopRequireDefault(_QueryOptionUtilJs);var _MapActionCreatorJs = require(
'./MapActionCreator.js');var _MapActionCreatorJs2 = _interopRequireDefault(_MapActionCreatorJs);

/**
 * Promise implementation, in local variable so that our code can be natural.
 *
 * @type {Function}
 */
var Promise;

/**
 * Organizes pieces inside its segment as simple key-value map. This means
 * segment piece granularity is limited to top-level values (you cannot
 * query a particular field, for instance).
 *
 * @CLIENT_SERVER
 */var 
MapSegment = (function (_Segment) {_inherits(MapSegment, _Segment);










  function MapSegment() {_classCallCheck(this, MapSegment);
    _get(Object.getPrototypeOf(MapSegment.prototype), 'constructor', this).call(this);
    this._queries = {};}


  /**
   * Creates MapActionCreator implementation. Will only be called once.
   *
   * ABSTRACT: To be overridden by child implementation.
   *
   * @return {MapActionCreator}
   */_createClass(MapSegment, [{ key: '_createActionCreator', value: 
    function _createActionCreator() {}



    /**
     * Child classes may want override merging behavior.
     *
     * @param {Object} optionA
     * @param {Object} optionB
     */ }, { key: '_mergeOptions', value: 
    function _mergeOptions(optionA, optionB) {
      return _QueryOptionUtilJs2['default'].mergeOptions(optionA, optionB);}


    /**
     * @param {Function} PromiseImpl
     */ }, { key: '_activate', value: 
    function _activate(PromiseImpl) {
      Promise = PromiseImpl;
      if (!this._actionCreator) {
        this._actionCreator = this._createActionCreator();}

      if (!(this._actionCreator instanceof _MapActionCreatorJs2['default'])) {
        throw new Error('MapSegment must be used in tandem with MapActionCreator.');}

      this._actionCreator._setPromise(PromiseImpl);}


    /**
     * We need to store both queries and options for later use. If the query is
     * already registered, we merge its options.
     *
     * @param {any} query
     * @param {Object} options
     * @return {string}
     */ }, { key: '_registerQuery', value: 
    function _registerQuery(query, options) {
      options = _QueryOptionUtilJs2['default'].initOptions(options);
      var queryId = this._actionCreator._generateQueryId(query);
      if (this._queries.hasOwnProperty(queryId)) {
        this._queries[queryId].options = this._mergeOptions(
        options, this._queries[queryId].options);} else 
      {
        this._queries[queryId] = { 
          query: query, 
          options: options };}


      return queryId;}


    /**
     * @param {string} queryId
     * @return {Object | Function}
     */ }, { key: '_createHydrateAction', value: 
    function _createHydrateAction(queryId) {
      return this._actionCreator.createLoadAction(
      this._queries[queryId].query, 
      this._queries[queryId].options, 
      true);}



    /**
     * @param {string} queryId
     * @return {Object}
     */ }, { key: '_createInitAction', value: 
    function _createInitAction(queryId) {
      return this._actionCreator._createInitActionObject(queryId);}


    /**
     * @return {Object}
     */ }, { key: '_createCleanAction', value: 
    function _createCleanAction() {
      return this._actionCreator._createCleanAction();}


    /**
     * @return {MapActionCreator}
     */ }, { key: '_getActionCreator', value: 
    function _getActionCreator() {
      return this._actionCreator;}


    /**
     * @param {Object} state
     * @param {string} queryId
     * @return {any}
     */ }, { key: '_getPieceObject', value: 
    function _getPieceObject(state, queryId) {
      return state[queryId];}


    /**
     * @param {any} segmentStateA
     * @param {any} segmentStateB
     * @return {boolean}
     */ }, { key: '_isStateEqual', value: 
    function _isStateEqual(segmentStateA, segmentStateB) {
      // We're not using immutable because we store simple maps.
      return segmentStateA === segmentStateB;}


    /**
     * @param prevSegmentState
     * @param segmentState
     * @param queryId
     * @return {?{data: ?any; errors: ?any}}
     */ }, { key: '_comparePiece', value: 
    function _comparePiece(prevSegmentState, segmentState, queryId) {
      // If state is equal, nothing has changed, since our reducer always
      // re-creates the object.
      if (this._isStateEqual(prevSegmentState, segmentState)) {
        return null;}


      // Test the query ID, it could be that this query hasn't changed.
      if (prevSegmentState[queryId] === segmentState[queryId]) {
        return null;}


      // Otherwise, state has changed, return piece object.
      return this._getPieceObject(segmentState, queryId);}


    /**
     * @return {Function}
     */ }, { key: '_getReducer', value: 
    function _getReducer() {var _this = this;
      var loadActionType = this._actionCreator._getLoadActionType();
      var initActionType = this._actionCreator._getInitActionType();
      var cleanActionType = this._actionCreator._getCleanActionType();
      return function (state, action) {
        // If state is undefined, return initial state.
        if (!state) state = {};
        var newState;
        switch (action.type) {
          case cleanActionType:
            // Nullifies the segment:
            return {};
            break;
          case loadActionType:
            // Replace the map entry with the new loaded one.
            newState = _this._createNewStateObj(state);
            newState[action.queryId] = action.payload;
            return newState;
            break;
          case initActionType:
            if (!state[action.queryId]) {
              newState = _this._createNewStateObj(state);
              newState[action.queryId] = action.payload;
              return newState;}

            break;}

        return state;};}



    /**
     * Create a new object, redux store state is supposed to immutable!
     *
     * @param {Object} state
     * @return {Object}
     */ }, { key: '_createNewStateObj', value: 
    function _createNewStateObj(state) {
      var newState = {}, queryId;
      for (queryId in state) {
        if (!state.hasOwnProperty(queryId)) continue;
        newState[queryId] = state[queryId];}

      return newState;} }]);return MapSegment;})(_SegmentJs2['default']);exports['default'] = MapSegment;module.exports = exports['default']; /**
                                                                                                                                               * @type {{[key: string]: {query: any; options: Object}}}
                                                                                                                                               */ /**
                                                                                                                                                   * @type {MapActionCreator}
                                                                                                                                                   */
//# sourceMappingURL=MapSegment.js.map